var EspiOWeb = window.EspiOWeb = {};

EspiOWeb.DisplayErrors = function (args, grid) {
    if (args.errors) {


        grid.one("dataBinding", function (e) {
            e.preventDefault();
            var chyby = "CHYBA\r\n=======================";
            $.each(args.errors, function (propertyName) {
                var msgs = "";
                if (args.errors[propertyName].errors.length) {
                    for (var i = 0; i < args.errors[propertyName].errors.length; ++i) {
                        msgs += "" + args.errors[propertyName].errors[i];
                    }

                }

                chyby += "\n"  + msgs;
            });

            iniBoxInfo(chyby);
        });
    }
};

$(function () {
    $(document).ajaxError(function (e, xhr) {
        if (xhr.status == 403) {
            var response = $.parseJSON(xhr.responseText);
            iniBoxInfo(response.Text);
            //window.location = response.LogOnUrl;
        }
    });
    
});
 
$(document).ready(function() {
  $("body").on("focus", "input, textarea, .k-dropdown", function() {
    $("label[for='" + this.id + "']").addClass("labelfocus");
  });
  $("body").on("blur", "input, textarea, .k-dropdown", function() {
    $("label").removeClass("labelfocus");
  });
});

//Pomoci Ajax uklada obsah formu do databaze
//pri chybe zobrazi validace, pokud vse projde, pak zavre okno
function SubmitForm(formContainer, url, window, funkce) {
    var dataModel = formContainer.serialize();

    $.ajax({
        url: url,
        type: 'post',
        data: dataModel,
        success: function (data) {
            if (data == true) {
                //ulozeno, zavolam externi funkci
                if (eval(funkce + ";"))
                    if ($(window) != null)
                        $(window).data("kendoWindow").close();
            }
            else {
                //chyba, exception je text chyby
                if (data.Exception != null) {
                    iniBoxError("", "error", data.Exception);
                }
                else
                //chyba, v data je formular, nactu ho do okna
                if (data.Errors) {
                    showValidationMessages($(window), data.Errors);
                }
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            iniBoxError(XMLHttpRequest, textStatus, errorThrown);
        }
    });
}

//zobrazi validacni popup ve stylu kendo UI
function showValidationMessages(container, errors) {
    for (var element in errors) {
        //add the validation message to the form
        //        container.find("[data-valmsg-for=" + element + "],[data-val-msg-for=" + element + "]")
        if (element == 'DB:') {
            iniBoxError(null, element, errors[element].errors);  
        } else {
            var elNoDots = element.replace(".", "\\.");

            var v = container.find("[data-valmsg-for=" + elNoDots + "],[data-val-msg-for=" + elNoDots + "]")

            v.replaceWith(validationMessageTmpl({ field: element, message: errors[element].errors }))
        }
    }
}

//vytvori tree s pomoci dataNodes
//pouziva se pro nacteni celeho treeview s pomoci Ajaxu na jeden zatah, protoze KendoUI to neumoznuje
function vytvorTree(td, treeName, dataNodes) {
    var inline = new kendo.data.HierarchicalDataSource({
        data: dataNodes,
        schema: {
            model: {
                children: "Items",
                expanded: true,
                id: "id",
                text: "Text",
                checked: true
            }
        }
    });


    if ($("#" + treeName) != null) {
        var tree = $("#" + treeName).data("kendoTreeView");

        if (tree != null) {
            tree.destroy();
            $("#" + treeName).remove();
        }
    }

    $(td).append("<div id='" + treeName + "'></div>");

    $("#" + treeName).kendoTreeView({
        checkboxes: {
            template: "# if(item.Items == null){# <input type='checkbox'  name='checkedNodes[#= item.id #]' checked='checked' />#}#"
        },
        dataSource: inline
    });
}


//doplní string nulama zleva
function zfill(num, len) { return (Array(len).join("0") + num).slice(-len); };

//refreshne grid po editaci - pouzito pro popup editaci a eventu OnRequestEnd
function gridRequestEnd(e) {
    var thereAreErrors = false;
    for (var propertyName in e.response.Errors) {
        thereAreErrors = true;
        break;
    }

    if ((!thereAreErrors) && ((e.type == "update") || (e.type == "create") || (e.type == "destroy"))) {
//        iniBoxInfo("Změny byly provedeny.");
        this.read();
    }
}

//Vlozi razitko do poznamky
function razitko(id, username) {
    var d1 = new Date();
    ta = document.getElementById(id);
    ta.value = ta.value + ' ' + d1.toLocaleString() + ' - ' + username + ': ';
    ta.focus();
}


//otevre okno s lovem
//title - titulek okna
//url - url pro vnitrek
//funkce - funkce, která se volá po stisku OK
//nazevId - nazev id, na ktery se grid zastreli
//valueId - hodnota, na kterou se grid zastreli
//TODO: zastřelit grid na hodnotu a nebo na první položku
function OpenLovWindow(title, url, funkce, nazevId, valueId, data) {
    var wndName = "gw-" + funkce;
    var wndSelector = "#" + wndName;
    var $div = $('<div id="' + wndName + '"/>').appendTo('body');
    $div.kendoWindow({
        width: "800px",
        height: "600px",
        title: title,
        modal: true,
        animation: false,
        resizable: true,
        actions: ["Maximize", "Close"],
        minHeight: 200,
        minWidth: 320,

        refresh: function () {
            var win = this;

            //implementace doubleclicku
            $(wndSelector + ' .k-grid').dblclick(function () {
                var grid = $(wndSelector + " .k-grid").data("kendoGrid");
                currentSelection = grid.select();
                var data = grid.dataItem(currentSelection);

                //volam externi funkci
                if (eval(funkce + "(data);"))
                    win.close();
            });

            $(wndSelector + ' #btnOk').click(function () {
                var grid = $(wndSelector + " .k-grid").data("kendoGrid");
                currentSelection = grid.select();
                var data = grid.dataItem(currentSelection);

                //volam externi funkci
                if (eval(funkce + "(data);"))
                    win.close();
            });
            $(wndSelector + ' #btnZpet').click(function () {
                win.close();
            });
            win.maximize();
        },

        close: function (e) {
            this.destroy();
        },
        resize: function () {
            var gridElement = $(wndSelector + " .k-grid"),
                    dataArea = gridElement.find(".k-grid-content"),
                    newHeight = gridElement.parent().innerHeight() - 10 - $(wndSelector + " #lov-tlacitka").outerHeight() - $(wndSelector + " #fullsearch").outerHeight() 
                        - $(wndSelector + " .nazev-stranky").outerHeight() - $(wndSelector + " .filterInfo").outerHeight(),
                    diff = gridElement.innerHeight() - dataArea.innerHeight();

            gridElement.height(newHeight);
            dataArea.height(newHeight - diff);
        }
    });

    dialog = $div.data("kendoWindow");
    dialog.refresh({
        url: url,
        data: data
    });
    dialog.center();
    dialog.open();
}

function returnTrue() {
    return true;
}

//otevre okno s lovem ve kterém je tree
//title - titulek okna
//url - url pro vnitrek
//funkce - funkce, která se volá po stisku OK
//TODO: zastřelit grid na hodnotu a nebo na první položku
function OpenTreeWindow(title, url, funkce, dataUrl) {
    var $div = $('<div id="tree-window" />').appendTo('body');
    $div.kendoWindow({
        width: "800px",
        height: "600px",
        title: title,
        modal: true,
        animation: false,
        resizable: true,
        actions: ["Maximize", "Close"],
        minHeight: 200,
        minWidth: 320,

        refresh: function () {
            var win = this;

            //implementace doubleclicku
            $("#tree-window #treeView").dblclick(function () {
                var treeView = $("#tree-window #treeView").data("kendoTreeView");
                var selectedNode = treeView.select();
                var data = treeView.dataItem(selectedNode);

                //volam externi funkci
                if (eval(funkce + "(data);"))
                    win.close();
            });

            $('#tree-window #btnOk').click(function () {
                var tree = $("#tree-window #treeView").data("kendoTreeView");
                currentSelection = tree.select();
                var data = tree.dataItem(currentSelection);

                //volam externi funkci
                if (eval(funkce + "(data);"))
                    win.close();
            });
            $('#tree-window #btnZpet').click(function () {
                win.close();
            });
            win.maximize();
        },

        close: function (e) {
            this.destroy();
        },
        resize: function () {
            var treeElement = $("#tree-window #treeView"),
                    newHeight = treeElement.parent().innerHeight() - 10 - $("#tree-window #lov-tlacitka").outerHeight() - $("#tree-window #fullsearch").outerHeight()
                        - $("#tree-window .nazev-stranky").outerHeight() - $("#tree-window .filterInfo").outerHeight();

            treeElement.height(newHeight);
        }

    });

    dialog = $div.data("kendoWindow");
    dialog.refresh({
        url: url,
        data: dataUrl,
        traditional: true
    });
    dialog.center();
    dialog.open();
}

//rekurzivni funkce, ktera vrati zaskrtle nebo nezaskrtle uzly treeview - pouze listy
var checkedNodesId = [];
function gatherStates(nodes, checked) {
    for (var i = 0; i < nodes.length; i++) {
        if ((nodes[i].checked == checked) && !nodes[i].hasChildren) {
            checkedNodesId.push(nodes[i].id);
        }

        if (nodes[i].hasChildren) {
            gatherStates(nodes[i].children.view(), checked);
        }
    }
}

//otevre okno s lovem
//title - titulek okna
//url - url pro vnitrek
//funkce - funkce, která se volá po stisku OK
//nazevId - nazev id, na ktery se grid zastreli
//valueId - hodnota, na kterou se grid zastreli
//TODO: zastřelit grid na hodnotu a nebo na první položku
function OpenEditWindow(title, url, dataUrl, urlUloz, funkce, width, height) {
    var $div = $('<div id="edit-window"/>').appendTo('body');
    $div.kendoWindow({
        width: width,
        height: height,
        minWidth: width,
        minHeight: height,
        title: title,
        modal: true,
        animation: false,
        resizable: true,
        actions: ["Close"],

        refresh: function () {
            var win = this;

            $('#edit-window #btnOk').click(function () {
                var infoForm = $("#edit-window #edit-form");
                var validator = infoForm.kendoValidator({
                        errorTemplate: '<div class="k-widget k-tooltip k-tooltip-validation" style="margin:0.5em"><span class="k-icon k-warning"> </span>#=message#<div class="k-callout k-callout-n"></div></div>'
                    }).data("kendoValidator");

                if (validator.validate()) {
                    SubmitForm(infoForm, urlUloz, "#edit-window", funkce);
                }
            });
            $('#edit-window #btnZpet').click(function () {
                win.close();
            });
        },

        close: function (e) {
            this.destroy();
        }
    });

    dialog = $div.data("kendoWindow");

    dialog.refresh({
        url: url,
        data: dataUrl
    });
    dialog.center();
    dialog.open();
}

//otevre okno s lovem
//title - titulek okna
//url - url pro vnitrek
//funkce - funkce, která se volá po stisku OK
//nazevId - nazev id, na ktery se grid zastreli
//valueId - hodnota, na kterou se grid zastreli
//TODO: zastřelit grid na hodnotu a nebo na první položku
function OpenViewWindow(title, url, dataUrl, urlUloz, funkce, width, height, maximize) {
    var $div = $('<div id="edit-window"/>').appendTo('body');
    $div.kendoWindow({
        width: width,
        height: height,
        minWidth: width,
        minHeight: height,
        title: title,
        modal: true,
        animation: false,
        resizable: true,
        actions: ["Maximize", "Close"],

        refresh: function () {
            var win = this;

            $('#edit-window #btnOk').click(function () {
                var infoForm = $("#edit-window #edit-form");
                var validator = infoForm.kendoValidator({
                        errorTemplate: '<div class="k-widget k-tooltip k-tooltip-validation" style="margin:0.5em"><span class="k-icon k-warning"> </span>#=message#<div class="k-callout k-callout-n"></div></div>'
                    }).data("kendoValidator");

                if (validator.validate()) {
                    SubmitForm(infoForm, urlUloz, "#edit-window", funkce);
                }
            });
            $('#edit-window #btnZpet').click(function () {
                win.close();
            });
        },

        close: function (e) {
            this.destroy();
        }
    });

    dialog = $div.data("kendoWindow");

    dialog.refresh({
        url: url,
        data: dataUrl
    });
    dialog.center();
    dialog.open();

    if(maximize)
        dialog.maximize();
}

//otevre okno s lovem
//title - titulek okna
//url - url pro vnitrek
//funkce - funkce, která se volá po stisku OK
//nazevId - nazev id, na ktery se grid zastreli
//valueId - hodnota, na kterou se grid zastreli
//TODO: zastřelit grid na hodnotu a nebo na první položku
function OpenEditSubjektWindow(title, url, dataUrl, urlUloz, funkce, width, height) {
    var $div = $('<div id="edit-subjekt-window"/>').appendTo('body');
    $div.kendoWindow({
        width: width,
        height: height,
        minWidth: width,
        minHeight: height,
        title: title,
        modal: true,
        animation: false,
        resizable: true,
        actions: ["Close"],

        refresh: function () {
            var win = this;

            $('#edit-subjekt-window #btnEditSubjektOk').click(function () {
                var infoForm = $("#edit-subjekt-window #edit-form");
                var validator = infoForm.kendoValidator({
                    errorTemplate: '<div class="k-widget k-tooltip k-tooltip-validation" style="margin:0.5em"><span class="k-icon k-warning"> </span>#=message#<div class="k-callout k-callout-n"></div></div>'
                }).data("kendoValidator");

                if (validator.validate()) {
                    //jeste mekka validace na IC mod 11
                    if ($("#edit-subjekt-window #edit-form #SUB_TYP").val() == "F") {
                        var ic = $("#edit-subjekt-window #edit-form #SUB_IC").val();
                        var soucet = (parseInt(ic.charAt(ic.length - 8)) || 0) * 8 + (parseInt(ic.charAt(ic.length - 7)) || 0) * 7 + (parseInt(ic.charAt(ic.length - 6)) || 0) * 6 + (parseInt(ic.charAt(ic.length - 5)) || 0) * 5 +
                        (parseInt(ic.charAt(ic.length - 4)) || 0) * 4 + (parseInt(ic.charAt(ic.length - 3)) || 0) * 3 + (parseInt(ic.charAt(ic.length - 2)) || 0) * 2;
                        if (((11 - (soucet % 11) - parseInt(ic.charAt(ic.length - 1)) || 0) % 10) != 0) {
                            ulozSubjektFunkce = funkce;
                            ulozSubjektUrl = urlUloz;
                            iniBoxQuest("IČ nesplňuje podmínku dělitelnosti 11, chcete přesto uložit subjekt?", ["Ano", "Ne"], 'ulozSubjekt');
                            return;
                        }
                    }
                    //konec mekke validace

                    SubmitForm(infoForm, urlUloz, "#edit-subjekt-window", funkce);
                }
            });
            $('#edit-subjekt-window #btnEditSubjektStorno').click(function () {
                win.close();
            });
        },

        close: function (e) {
            this.destroy();
        }
    });

    dialog = $div.data("kendoWindow");

    dialog.refresh({
        url: url,
        data: dataUrl
    });
    dialog.center();
    dialog.open();
}
//funkce kvuli zavreni dialogu na modulo 11
var ulozSubjektFunkce;
var ulozSubjektUrl;
function ulozSubjekt(e) {
    if (e == 'Ano') {
        var infoForm = $("#edit-subjekt-window #edit-form");
        SubmitForm(infoForm, ulozSubjektUrl, "#edit-subjekt-window", ulozSubjektFunkce);
    }
}

//zjisti velikost souboru
function getFileSize(filepath) {
    var myFSO = new ActiveXObject("Scripting.FileSystemObject");
    var thefile = myFSO.getFile(filepath);
    return thefile.size;
}

//vlozi cookie dat za inspektorat, je nutno poustet z checkboxu s id chkInspektorat
function DataZaInspektorat(grid) {
    $.cookie("DataZaInspektorat", $("#chkInspektorat").prop('checked'), { path: '/' });
    $("#" + grid).data("kendoGrid").dataSource.read();
}

function gridDataBound(arg) {
    var h = arg.sender.wrapper.children(".k-grid-toolbar");

    var currentFilter = arg.sender.dataSource.filter(); // get current filter
    s = h.children("#grd_filtrovano");

    if (currentFilter == null) {
        if ((s != null) && (s.length > 0))
            s[0].innerHTML = "";
    }
    else {
        if ((s != null) && (s.length > 0))
            s[0].innerHTML = "<span style='left: -100%; position: relative;'><a class='k-button k-button-icon' style='color: red;' title='Zrušit filtr' onclick='javascript:GridZrusitFiltry(this)'><strong>&nbsp;FILTROVÁNO&nbsp;</strong><span class='k-icon k-i-close'></span></a></span>";
        else
            h.append("<span id='grd_filtrovano' style='left: 100%; position: absolute;'><span style='left: -100%; position: relative;'><a class='k-button k-button-icon' style='color: red;' title='Zrušit filtr' onclick='javascript:GridZrusitFiltry(this)'><strong>&nbsp;FILTROVÁNO&nbsp;</strong><span class='k-icon k-i-close'></span></a></span></span>");
    }
}

function GridZrusitFiltry(ds) {
    $(ds).closest(".k-grid").data("kendoGrid").dataSource.filter(null);
}

function ZobrazZmeny(url) {
    win = $("#windowPosledniZmeny").data("kendoWindow");
    win.refresh({
        url: url
    });
    win.center();
    win.open();
}

function ZobrazWindowNastroje(url, title) {
    win = $("#windowNastroje").data("kendoWindow");
    win.title(title);
    win.refresh({
        url: url
    });
    win.center();
    win.open();
}

function onFullSearchKeyDown(event) {
    if (event == undefined)
        event = window.event;

    var keycode = (event.keyCode ? event.keyCode : event.which);
    if (keycode == '13') {
        var elm = $($(event.currentTarget).siblings('#btnHledat'));
        elm.trigger('click');
    }
//        document.getElementById('btnHledat').click();
}

function onLovKeyDown(event) {
    if (event == undefined)
        event = window.event;

    var keycode = (event.keyCode ? event.keyCode : event.which);
    if (keycode == '120') { //F9
        var elm = $($(event.currentTarget).siblings('.k-button'));
        elm.trigger('click');
    }
    //        document.getElementById('btnHledat').click();
}

function GridDateFilter(control) {
    $(control).kendoDatePicker();
}

function GridNumericFilter(control) {
    $(control).kendoNumericTextBox();
}

function GridSaveState(e) {
  var dataSource = e.dataSource;
    
  var data = {
    page: dataSource.page(),
    pageSize: dataSource.pageSize(),
    sort: dataSource.sort(),
    filter: dataSource.filter()
  };
    $.cookie("gridState_" + e.dataSource.options.transport.read.url, JSON.stringify(data));
}

function GridLoadState(grid) {
    var cook = $.cookie("gridState_" + grid.dataSource.options.transport.read.url)
    var state = null;

    if (cook != null) 
        state = JSON.parse(cook);

    if (state) {
        grid.dataSource.query(state);
//        grid.dataSource.page(state.page);
//        grid.dataSource.sort(state.sort);
//        grid.dataSource.filter(state.filter);
    }
    else {
        grid.dataSource.read();
    }
}

//nastavi grid pro fulltext search a refreshne data
function fulltextButtonClick(t, grid, text) {
    $($(t).parent().siblings("#" + grid)).data("fulltext", $($(t).siblings("#" + text)).val());

    //refreshuje se bud grid nebo treeview
    if ($($(t).parent().siblings("#" + grid)).data("kendoGrid") != null)
        $($(t).parent().siblings("#" + grid)).data("kendoGrid").dataSource.read();

    if ($($(t).parent().siblings("#" + grid)).data("kendoTreeView") != null)
        $($(t).parent().siblings("#" + grid)).data("kendoTreeView").dataSource.read();
}

//pokud ma uzivatel pravo, tak pusti funkci, jinak zobrazi hlasku v msg
function IfUserMaPravo(url, pravo, msg, CallBack) {
    $.ajax({
        url: url,
        type: 'post',
        data: { pravo: pravo },
        success: function (data) {
            if (data == true) {
                CallBack();
            }
            else {
                if((msg == null) || (msg == ''))
                    msg = 'Nemáte právo pro tuto akci.';

                iniBoxInfo(msg);
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            iniBoxError(XMLHttpRequest, textStatus, errorThrown);
        }
    });
}

function GridZjistiPocet() {
    var sender = $(window.event.target || window.event.srcElement);
    var grid = $(sender).parent().parent().parent().data("kendoGrid");
    var ds = grid.dataSource;
    var getTotal = ds._getTotal;

    if (getTotal != true) {
        grid.pager.options.messages.display = "<a class='pager_click' href='#' onclick='javascript:GridZjistiPocet()'>Zobrazují se položky {0} až {1} z celkového počtu {2}</a>&nbsp;<div class='img_slow'/>";
        ds._getTotal = true;
        ds.read();
        $("a[title=\"Poslední stránka\"]").prop('title', "Poslední  stránka");
    }
    else {
        grid.pager.options.messages.display = "<a class='pager_click' href='#' onclick='javascript:GridZjistiPocet()'>Zobrazují se položky {0} až {1} z celkového počtu ???</a>&nbsp;<div class='img_fast'/>";

        ds._getTotal = false;
        ds.read();
        $("a[title=\"Poslední  stránka\"]").prop('title', "Poslední stránka");
    }
    return false;
}

function gridKeypress(event) {
    var keycode = (event.keyCode ? event.keyCode : event.which);
    if (keycode == '13') {
        var elm = $($(document).context.activeElement).parents('.k-grid');
        if ((elm != null) && elm.length > 0) {
            var grid = $(elm[0]).data("kendoGrid");
            grid.editRow(grid.current());
        }
    }
    if (keycode == '45') {
        elm = $($(document).context.activeElement).parents('.k-grid');
        if ((elm != null) && elm.length > 0) {
            grid = $(elm[0]).data("kendoGrid");
            grid.addRow(grid.current());
        }
    }
    if (keycode == '46') {
        elm = $($(document).context.activeElement).parents('.k-grid');
        if ((elm != null) && elm.length > 0) {
            grid = $(elm[0]).data("kendoGrid");
            grid.removeRow(grid.current());
        }
    }
}
