﻿
/*Třída pro řízení iniGridu*/
function IniGrid() {

    //validační hint editací
    this.validationMessageTmpl = kendo.template($("#validation-message").html());

    /*Vytváří filtrační dialog s comboboxem pro filtraci výčtových hodnot*/
    this.GridFiltrEnums = function (element, url) {
        $(element.context.parentNode.firstChild).find("k-filter-help-text").context.innerHTML = "zobrazit položky kde hodnota je";
        var el = $(element.context.parentNode).find("select:eq(0)");

        setTimeout(function () {
            el.data("kendoDropDownList").wrapper.hide();
        });

        element.kendoDropDownList({
            dataSource: {
                transport: {
                    dataType: "jsonp",
                    read: url
                }
            },
            dataTextField: "Text",
            dataValueField: "Value",
            optionLabel: "--Vyberte hodnotu--"
        });
        element.focus()
    };

    var deleteGrid;
    var deleteData;
    /*Konfirmační dialog pro mazání objektu*/
    this.GridDelete = function (e) {
        deleteGrid = $(e).closest(".k-grid").data("kendoGrid");
        var tr = $(e).closest("tr"); //get the row for deletion
        deleteData = deleteGrid.dataItem(tr); //get the row data so it can be referred later

        iniBoxQuest("<br/>Opravdu chcete smazat tento záznam?<br/>", ["Ano", "Ne"], "iniGrid.GridDeleteConfirmation");
    };

    /*vlastní mazání řádku*/
    this.GridDeleteConfirmation = function (e) {
        if (e == "Ano") {
            deleteGrid.dataSource.remove(deleteData);
            deleteGrid.dataSource.sync();
            showWaitWnd("Probíhá mazání záznamu");
        }
    };

    /*export všech dat gridu do CSV*/
    /* Modified from https://github.com/uber-rob/kendo-grid-csv-download */
    this.ExportToCSV = function (e, typ) {
        showWaitWnd("Připravuje se export...")

        typ = typ || "csv";

        var grid = e; //$(e.target).parents('.k-grid').data("kendoGrid");
        // Get access to basic grid data
        var datasource = grid.dataSource;
        var originalPageSize = datasource.pageSize();
        var originalPage = datasource.page();

        // Remove the success function since we don't care about what happens after we get the data
        // (and the prototype success function causes problems when we copy the datasource over from the grid)
        datasource.success = function (data) {
            var csv = '';

            // Add the header row
            for (var i = 0; i < grid.columns.length; i++) {
                var title = grid.columns[i].title,
                field = grid.columns[i].field;
                if (typeof (field) === "undefined") { continue; /* no data! */ }
                if (typeof (title) === "undefined") { title = field }

                title = title.replace(/"/g, '""');
                title = title.replace(';', ',');
                csv += '"' + title + '"';
                if (i < grid.columns.length - 1) {
                    csv += ";";
                }
            }
            csv += "\n";

            // Add each row of data
            $.each(data.Data, function (index, row) {
                // Do a first pass to parse any dates (may eventually need to parse other types of received values here)
                for (var i = 0; i < grid.columns.length; i++) {
                    var fieldName = grid.columns[i].field;
                    if (typeof (fieldName) === "undefined") { continue; }
                    if (typeof row[fieldName] == "string" && row[fieldName].lastIndexOf("/Date(", 0) === 0) {
                        row[fieldName] = kendo.parseDate(row[fieldName]);
                    }
                }

                // Now generate the actual values
                for (var i = 0; i < grid.columns.length; i++) {
                    var fieldName = grid.columns[i].field;
                    if (typeof (fieldName) === "undefined") { continue; }

                    // Get the template and use it to get the display value
                    var tmpl = grid._cellTmpl(grid.columns[i], {});
                    var kt = kendo.template(tmpl);
                    value = kt(row);

                    // Strip any HTML (needs to be inclosed in an outer tag to work)
                    // Also strip any elements with the 'no-export' class
                    // Also remove any label elements since they get used often in links
                    var html = $('<div>' + value + '</div>');
                    html.find('.label').remove();
                    html.find('.no-export').remove();
                    value = html.text().trim();

                    // Format for CSV (escape quotes and add the comma)
                    value = value.replace(/"/g, '""');
                    value = value.replace(';', ',');
                    csv += '"' + value + '"';
                    if (i < grid.columns.length - 1) {
                        csv += ";";
                    }
                }
                csv += "\n";
            });
            hideWaitWnd();
            //EXPORT TO BROWSER
            if(typ == "csv")
                postToURL(window.CsvExportUrl, { data: csv, fileName: 'data.csv', contentType: 'text/Csv' });
            if (typ == "xls")
                postToURL(window.XlsExportUrl, { data: csv, fileName: 'data.xlsx', contentType: 'application/vnd.ms-excel' });


            // Reset back to original values and reset the datasource
            datasource.pageSize(originalPageSize);
            datasource.page(originalPage);
            delete datasource.success;

            // Reset the datasource now that we're done
            datasource._dequeueRequest();
            datasource.view();
            kendo.ui.progress(grid.element, false);
        }

        // Increase page size to cover all the data and then trigger fetching and processing of all the data
        datasource.pageSize(datasource.total());
        datasource.view();
    };

    /*pokud je grid bez celkoveho poctu, tak tato funkce přepíná funkčnost stránkování*/
    this.ZjistiPocet = function () {
        var sender = $(window.event.target || window.event.srcElement);
        var grid = $(sender).parent().parent().parent().data("kendoGrid");
        var ds = grid.dataSource;
        var getTotal = ds._getTotal;

        if (getTotal != true) {
            grid.pager.options.messages.display = "<a class='pager_click' href='#' onclick='javascript:GridZjistiPocet()'>Zobrazují se položky {0} až {1} z celkového počtu {2}</a>&nbsp;<div class='img_slow'/>";
            ds._getTotal = true;
            ds.read();
            $("a[title=\"Poslední stránka\"]").prop('title', "Poslední  stránka");
        }
        else {
            grid.pager.options.messages.display = "<a class='pager_click' href='#' onclick='javascript:GridZjistiPocet()'>Zobrazují se položky {0} až {1} z celkového počtu ???</a>&nbsp;<div class='img_fast'/>";

            ds._getTotal = false;
            ds.read();
            $("a[title=\"Poslední  stránka\"]").prop('title', "Poslední stránka");
        }
        return false;
    };


    /*zruší filtraci na gridu*/
    this.ZrusitFiltry = function (ds) {
        $(ds).closest(".k-grid").data("kendoGrid").dataSource.filter(null);
    };

    /*zapamatuje si pozici vybraného řádku gridu pro případný refresh*/
    this.Change = function (e) {
        var keyValues = null;
        selectedData = e.sender.dataItem(e.sender.select()[0]);
        if (selectedData) {
            var keys = ["Id"];
            var pks = e.sender.wrapper.attr("data-pks");
            if (pks)
                keys = pks.split(",");
            var keyValues = {};
            jQuery.each(keys, function(index, item){
                keyValues[item] = selectedData[item];
            });
        }
        e.sender.wrapper.data("last-position", keyValues);
    }

    /*eventa, která se spouští po refreshi gridu*/
    this.DataBound = function (arg) {
        hideWaitWnd();

        var h = arg.sender.wrapper.children(".k-grid-toolbar");

        var currentFilter = arg.sender.dataSource.filter(); // get current filter
        s = h.children("#grd_filtrovano");

        if (currentFilter == null) {
            if ((s != null) && (s.length > 0))
                s[0].innerHTML = "";
        }
        else {
            if ((s != null) && (s.length > 0))
                s[0].innerHTML = "<span class='ini-toolbar-element'><a class='k-button k-button-icon thfiltrovano' title='Zrušit filtr' onclick='javascript:iniGrid.ZrusitFiltry(this)'>&nbsp;FILTROVÁNO&nbsp;<span class='k-icon k-i-close'></span></a></span>";
            else
                h.append("<span id='grd_filtrovano'><span class='toolbar-filterbtn'><a class='k-button k-button-icon thfiltrovano' title='Zrušit filtr' onclick='javascript:iniGrid.ZrusitFiltry(this)'>&nbsp;FILTROVÁNO&nbsp;<span class='k-icon k-i-close'></span></a></span></span>");
        }

        //selectnu poslední vybraný řádek a nebo první řádek gridu
        var lastSel = arg.sender.wrapper.data("last-position");
        if (lastSel) {
            var keys = ["Id"];
            var pks = arg.sender.wrapper.attr("data-pks");
            if (pks)
                keys = pks.split(",");

            var data = arg.sender.dataSource.view();
            for (var i = 0; i < data.length; i++) {
                if (data[i][keys[0]] == lastSel[keys[0]]) {
                    //selectnu
                    arg.sender.select(arg.sender.table.find("tr[data-uid=" + data[i]["uid"] + "]"));

                    //zascrolluju na pozici, pokud to musí být
                    var scrollContentOffset = arg.sender.element.find("tbody").offset().top;
                    var selectContentOffset = 0

                    if (arg.sender.select().offset() != null) 
                        arg.sender.select().offset().top;

                    var distance = selectContentOffset - scrollContentOffset;

                    if ((distance < scrollContentOffset) || (distance > arg.sender.element.find(".k-grid-content").height() - 20)) {
                        arg.sender.element.find(".k-grid-content").animate({
                            scrollTop: distance
                        }, 400);
                    }
                    break;
                }
            }
        }
        else
            arg.sender.select(arg.sender.table.find('tr:has(td)'));

        //poli v zahlavi, ktere je filtrovano nastavim background color na svetle zelenou
        //        $(".k-header").removeClass("thfiltrovano");
        //        $(".k-grid-header th:has(a.k-state-active)").addClass("thfiltrovano");
    };

    /*refreshne grid po editaci - pouzito pro popup editaci a eventu OnRequestEnd datasource*/
    this.RequestEnd = function (e) {
        var thereAreErrors = false;
        if ((e != null) && (e.response != null)) {
            for (var propertyName in e.response.Errors) {
                thereAreErrors = true;
                break;
            }
        }

        if ((!thereAreErrors) && ((e.type == "update") || (e.type == "create") || (e.type == "destroy"))) {
            if ((e.response != null) && (e.response.Data != null) && (e.response.Data.length > 0)
         && (e.response.Data[0].AfterSaveMessage != null) && (e.response.Data[0].AfterSaveMessage != ""))
                iniBoxInfo(e.response.Data[0].AfterSaveMessage);

            this.read();
        }
    };

    /*odchytává errory na datasource*/
    this.HandleErrors = function(e, ds) {
        if (e.errors !== false) {
            $(".k-grid").each(function () {
                var grid = $(this).data("kendoGrid");
                if (grid !== null && grid.dataSource == e.sender) {
                    grid.one("dataBinding", function (grd) {
                        grd.preventDefault();   // cancel grid rebind
                    });
                }
            });

            showValidationMessages($("#edit-form"), e.errors);
        }
    };
    
    /*otevře editační okno*/
    this.GridEdit = function (e, isEdit) {
        var updateGrid = $(e.target).parents('.k-grid').data("kendoGrid");
        var url = updateGrid.wrapper.attr("data-editurl");
        var urlUloz = updateGrid.wrapper.attr("data-saveurl");
        var pks = updateGrid.wrapper.attr("data-pks");
        var nazev = updateGrid.wrapper.attr("data-editnazev");
        var okFunkce = updateGrid.wrapper.attr("data-editokfunkce");
        var closeFunkce = updateGrid.wrapper.attr("data-editclosefunkce");
        var okSuccessFunkce = updateGrid.wrapper.attr("data-editsuccessfunkce");
        var okFailedFunkce = updateGrid.wrapper.attr("data-editfailedfunkce");

        var keys = ["Id"];
        if (pks)
            keys = pks.split(",");

        var keyValues = null;

        if (isEdit) {//update, naplním PK (keyValues)
            var tr = $(e.target).closest("tr");
            updateData = updateGrid.dataItem(tr);

            var keyValues = {};
            jQuery.each(keys, function (index, item) {
                keyValues[item] = updateData[item];
            });
        }

        var $div = $('<div id="edit-window"></div>');
        $div.kendoWindow({
            modal: true,
            resizable: false,
            actions: ["Close"],
            title: nazev,

            // http://docs.telerik.com/kendo-ui/api/javascript/ui/window#events-refresh
            refresh: function () {
                var win = this;
                this.open();
                this.center();
                hideWaitWnd("wait-edit");

                $(win.wrapper).find("#btnEditOk").click(function (e) {
                    if ((okFunkce != null) && (okFunkce != ""))
                        eval(okFunkce + "();");

                    var infoForm = $(win.wrapper).find("#edit-form");
                    var validator = infoForm.kendoValidator({
                        errorTemplate: '<div class="k-widget k-tooltip k-tooltip-validation" style="margin:0.5em"><span class="k-icon k-warning"> </span>#=message#<div class="k-callout k-callout-n"></div></div>'
                    }).data("kendoValidator");

                    if (validator.validate()) {
                        /*klientska validace hotova, pokusim se ulozit na serveru*/
                        var dataModel = infoForm.serialize();
                        var updateUrl = urlUloz;

                        if ((!updateUrl) || (0 === updateUrl.length))
                            updateUrl = url;

                        showLoadingElement($(win.wrapper).find(".k-window-content"));
                        $.ajax({
                            url: updateUrl,
                            type: 'post',
                            data: dataModel,
                            cache: false,
                            success: function (data) {
                                hideLoadingElement($(win.wrapper));
                                /*nastaly chyby, zobrazim je v okne, pripadne zobrazim dialog*/
                                if (!$.isEmptyObject(data.Errors) || !$.isEmptyObject(data.Error)) {
                                    if ((okFailedFunkce != null) && (okFailedFunkce != "")) eval(okFailedFunkce + "();");
                                    iniGrid.ShowValidationMessages(infoForm, data.Errors, data.Error);
                                } else {
                                    if (data.Model) {//zastrelim na pridanou polozku
                                        var keyValues = {};
                                        jQuery.each(keys, function (index, item) {
                                            keyValues[item] = data.Model[item];
                                        });
                                    }
                                    updateGrid.wrapper.data("last-position", keyValues);

                                    if ((okSuccessFunkce != null) && (okSuccessFunkce != ""))
                                        eval(okSuccessFunkce + "(data);");
                                    win.close();
                                    updateGrid.dataSource.read();
                                }
                            },
                            error: function (XMLHttpRequest, textStatus, errorThrown) {
                                if (XMLHttpRequest.status == 401) {
                                    // login timeout
                                    handleLoginTimeoutError(XMLHttpRequest, textStatus, errorThrown);
                                } else {
                                    hideLoadingElement($(win.wrapper));
                                    if ((okFailedFunkce != null) && (okFailedFunkce != "")) eval(okFailedFunkce + "();");
                                    iniBoxError(XMLHttpRequest, textStatus, errorThrown);
                                }
                            }
                        });
                    }
                    else {
                        if ((okFailedFunkce != null) && (okFailedFunkce != ""))
                            eval(okFailedFunkce + "();");
                    }
                });

                $(win.wrapper).find('#btnEditStorno').click(function () {
                    win.close();
                });
            },

            //http://docs.telerik.com/kendo-ui/api/javascript/ui/window#events-close
            close: function (e) {
                if ((closeFunkce != null) && (closeFunkce != "")) eval(closeFunkce + "(e);");
                this.destroy();
            },

            //http://docs.telerik.com/kendo-ui/api/javascript/ui/window#events-error
            error: function (e) {
                if (e.xhr.status == 401) {
                    // login timeout
                    handleLoginTimeoutError(e.xhr, e.status, e);
                }
            }

        });

        dialog = $div.data("kendoWindow");

        // http://docs.telerik.com/kendo-ui/api/javascript/ui/window#methods-refresh
        dialog.refresh({
            type: "get",
            url: url,
            data: keyValues,
            contentType: "application/json"

        });
        // http://docs.telerik.com/kendo-ui/api/javascript/ui/window#events-error
        showWaitWnd("Načítá se formulář...", "wait-edit");
    };

    /*zobrazi validacni popupy ve stylu kendo UI*/
    this.ShowValidationMessages = function (container, errors, error) {
        var message = "";
        if (error)
            message = error;

        for (var element in errors) {
            //add the validation message to the form
            //        container.find("[data-valmsg-for=" + element + "],[data-val-msg-for=" + element + "]")
            var elNoDots = element.replace(".", "\\.");
            var elNoDots = elNoDots.replace(":", "\\:");

            var v = container.find("[data-valmsg-for=" + elNoDots + "],[data-val-msg-for=" + elNoDots + "]")

            if (v.length > 0)
                v.replaceWith(this.validationMessageTmpl({ field: element, message: errors[element][0].ErrorMessage }));
            else {
                if (message == "")
                    message = errors[element][0].ErrorMessage;
                else
                    message = message + "<br/>" + errors[element][0].ErrorMessage;
            }
        }
        if (message != "")
            iniBoxError(null, "Nastala chyba", message);
    };

    var deleteServerButton;
    /*Pokusí se smazat na serveru, při neúspěchu otevře dialogové okno s hláškou, při úspěchu refreshne grid*/
    this.GridServerDelete = function (e) {
        deleteServerButton = $(e.target);

        iniBoxQuest("Opravdu chcete smazat tento záznam?", ["Ano", "Ne"], "iniGrid.GridServerDeleteConfirmation");
    };

    /*vlastní mazání řádku*/
    this.GridServerDeleteConfirmation = function (e) {
        if (e == "Ano") {
            showWaitWnd("Probíhá mazání záznamu");

            var deleteServerGrid = $(deleteServerButton).closest(".k-grid").data("kendoGrid");
            var deleteServerUrl = deleteServerGrid.wrapper.attr("data-deleteurl"); ;
            var tr = $(deleteServerButton).closest("tr");
            var deleteServerData = JSON.stringify(deleteServerGrid.dataItem(tr));


            $.ajax({
                url: deleteServerUrl,
                type: 'post',
                data: deleteServerData,
                contentType: "application/json",
                cache: false,
                success: function (data) {
                    /*nastaly chyby, zobrazim dialog*/
                    if (!$.isEmptyObject(data.Errors) || !$.isEmptyObject(data.Error)) {
                        hideWaitWnd();
                        var message = "";
                        if (data.Error)
                            message = data.Error;
                        for (var element in data.Errors) {
                            if (message == "")
                                message = data.Errors[element][0].ErrorMessage;
                            else
                                message = message + "<br/>" + data.Errors[element][0].ErrorMessage;
                        }

                        iniBoxError(null, "Při mazání nastala chyba", message);
                    }
                    else {
                        deleteServerGrid.dataSource.read();
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    hideWaitWnd();
                    iniBoxError(XMLHttpRequest, textStatus, errorThrown);
                }
            });
        }
    };

    this.FilterInit = function (e) {
        var popup = e.container.data("kendoPopup");
        popup.bind("activate", function (e) {
            this.element.find(".k-textbox").focus();
        });
    };

    ///spousti se po stisku tlacitka vyhledavani na LOVu, nastavi parametr datasetu gridu a refreshne grid
    this.Vyhledat = function (e) {
        var ds = $(e.target).closest(".k-grid").data("kendoGrid").dataSource;
        var editbox = $(e.currentTarget).siblings(".find-edit");

        ds.transport.options.read.data = { data_fullsearch: editbox.val() };
        ds.page(1);
    };
    ///Zrusi vyhledavani
    this.VyhledatZrus = function (e) {
        var ds = $(e.target).closest(".k-grid").data("kendoGrid").dataSource;
        var editbox = $(e.currentTarget).siblings(".find-edit");
        editbox.val(null);

        ds.transport.options.read.data = { data_fullsearch: null };
        ds.page(1);
    };
    ///enter spusti vyhledavani
    this.FindEditKeyDown = function (e) {
        var code = (e.keyCode ? e.keyCode : e.which);
        if (code == 13) {
            var btn = $(e.currentTarget).siblings(".find-button");
            btn.trigger('click');
            e.preventDefault();
        }
    };
}


/*Třída pro řízení IniTreeView*/
function IniTreeView() {

    this.GetSelectedObject = function (treeViewName) {
        //var tv = $('.' + treeViewName).data('kendoTreeView'),
        var tv = this.GetTreeView(treeViewName);
        selected = tv.select(),
        item = tv.dataItem(selected);
        if (item) {
            return item;
        } else {
            //alert('Nothing selected');
        }
        return null;
    }

//    function OpenRowClick(e) {
//        var updateGrid = $(e.target).parents('.k-treeview').data("kendoTreeView");
//        var url = updateGrid.wrapper.attr("data-editurl");
//        var pks = updateGrid.wrapper.attr("data-pks");
//    }

//    function DeleteRowClick(e) {
//        var updateGrid = $(e.target).parents('.k-treeview').data("kendoTreeView");
//        var pks = updateGrid.wrapper.attr("data-pks");
//        var deleteServerUrl = deleteServerGrid.wrapper.attr("data-deleteurl");
//    }

    this.GetTreeView = function(treeView){
        //debugger;

        var treeViewElement = null;
        if(!treeView) {
            //return null;
            treeViewElement = $('.k-treeview');
            if( Object.prototype.toString.call( treeViewElement ) === '[object Array]' ) {
                treeViewElement = treeViewElement[0];
            }
        } else if (treeView.element && treeView.element.hasClass("k-treeview")) {
            return treeView; // uz mame treeview akorat to volam podruhe
        } else if(treeView instanceof jQuery){
            treeViewElement = treeView.getKendoTreeView();
        } else {
            treeViewElement = $("#"+treeView);
            
            if(!treeViewElement){
                event = treeView || window.event
                if(event.target){
                    treeViewElement = $(e.target).parents('.k-treeview');
                } else if(event.srcElement){
                    treeViewElement = $(e.srcElement).parents('.k-treeview');
                }

            }
       }

       return treeViewElement.data("kendoTreeView");
    }

    this.CreateActionArgs = function (treeView, attributeUrlName) {
        var args = {
            Cancel: false,
        };

        if (!attributeUrlName) {
            attributeUrlName = "data-editurl";
        }

        // get treeview
        var treeView = this.GetTreeView(treeView);

        // get PK
        var pks = treeView.wrapper.attr("data-pks");
        if (!pks) {
            console.log("No PK defined in attribute data_pks!");
        }
        if (Object.prototype.toString.call(pks) === '[object Array]') {
            //todo: vyres kdyz je PK slozeny z vice
        } else {
            // nic nedelam promena je string, jeden klic
        }
        args.Pk = pks;


        var url = treeView.wrapper.attr(attributeUrlName);
        if (!url) {
            console.error("No edit url defined in attribute " + attributeUrlName + "!");
        } else {
        }
        args.Url = url;

        // get selected row data
        var dataRowObj = this.GetSelectedObject(treeView);
        args.DataRowObj = dataRowObj;
        if(dataRowObj){
            //id, zatim neresim slozeny klice
            args.Id = dataRowObj[pks];
        }else{
            args.Id = null;
        }


        return args;
    }

    /// funkce pro Edit zaznamu
    /// treeView: nic - najde si prvni treeview, Id, JQuery element, primo kendotreeView
    /// successCallback - z CallAjax coze je successCallback(AjaxJasonArgs data)
    /// errorCallback -  z CallAjax coze je errorCallback(AjaxJasonArgs data, int status)
    this.Edit = function (treeView, successCallback, errorCallback) {
        //debugger;

        // get treeview
        var treeView = this.GetTreeView(treeView);
        if (!treeView) {
            console.error("Can not find any treeView!");
            return;
        }

        var args = this.CreateActionArgs(treeView, "data-editurl");


        if (!args.DataRowObj) {
            console.log("No row selected! Can not return row data object.");
        }


        var retEditArgs = this.RunCustomFunc(treeView, args, "data-customEditFunc"); //"data-customDeleteFunc"
        if (retEditArgs && retEditArgs.Cancel) {
            return;
        }

        alert("Edit url: " + retEditArgs.Url + "\?id=" + retEditArgs.Id)

        if(retEditArgs.Url == null || retEditArgs.Id == null){
            console.log("Url or Id not present, can not run serverside ajax!");
        } else {
            //Call open form
//            CallAjax(null, retEditArgs.Url, retEditArgs.Id, "Mazání záznamu ...", function(data){
//                // refresh data
//                treeView.dataSource.read();
//                if (successCallback && typeof (successCallback) === "function") {
//                    successCallback(null);
//                }
//            }, errorCallback);
        }

    }

    /// funkce pro Mazani zaznamu
    /// treeView: nic - najde si prvni treeview, Id, JQuery element, primo kendotreeView
    /// successCallback - z CallAjax coze je successCallback(AjaxJasonArgs data)
    /// errorCallback -  z CallAjax coze je errorCallback(AjaxJasonArgs data, int status)
    this.Delete = function (treeView, successCallback, errorCallback) {
        //debugger;

        // get treeview
        var treeView = this.GetTreeView(treeView);
        if (!treeView) {
            console.error("Can not find any treeView!");
            return;
        }

        var args = this.CreateActionArgs(treeView, "data-deleteurl");


        if (!args.DataRowObj) {
            console.log("No row selected! Can not return row data object.");
        }


        var retEditArgs = this.RunCustomFunc(treeView, args, "data-customDeleteFunc");
        if (retEditArgs && retEditArgs.Cancel) {
            return;
        }

       // alert("Delete url: " + retEditArgs.Url + "\?id=" + retEditArgs.Id)


        // smazeme ajaxem na serveru
        if(retEditArgs.Url == null || retEditArgs.Id == null){
            console.log("Url or Id not present, can not run serverside ajax!");
        } else {
            CallAjax(null, retEditArgs.Url, {Id: retEditArgs.Id}, "Mazání záznamu ...", function(data){
                // refresh data
                treeView.dataSource.read(); // toto prenacteni zabali vse rozbalene
                //  treeView.remove($(this).closest('.k-item'));
                if (successCallback && typeof (successCallback) === "function") {
                    successCallback(null);
                }
            }, errorCallback);
        }

    }

    this.RunCustomFunc = function (treeView, args, customFuncAttibuteName) {
       // debugger;
        var customEditFunc = treeView.wrapper.attr(customFuncAttibuteName);
        if (typeof window[customEditFunc] === "function") {
            window[customEditFunc](treeView, args);
        } else {
            console.log("No data-customEditFunc defined.")
        }
        return args;
    }


    this.Refresh = function(treeView){
            // get treeview
        var treeView = this.GetTreeView(treeView);
        if (!treeView) {
            console.error("Can not find any treeView!");
            return;
        }

        var expandedNodes = treeView.element.find(".k-item").filter(function () {
            return $(this).attr("data-expanded") === "true";
        });


        var treeIdArr = new Array();
        $(expandedNodes).each(function () {
            //serialized += treeView.text(this) + "|";
            //treeIdArr.get(this.Id);
            var treeId = treeView.dataItem(this).id;
            treeIdArr.push(treeId);
        });

        //var deserialized = serialized.split("|H|");
        var dataSource = treeView.element.getKendoTreeView().dataSource;
        $(treeIdArr).each(function () {
            var node = dataSource.get(this);

            treeView.expand(node);
        });
    }

}

